/************************************************************************/
/*  Routines for generating blockette 2000 and Quanterra BPR            */
/*  (Blockette Piped Record) structures.                                */
/*  Receiver independent.                                               */
/*                                                                      */
/*      Douglas Neuhauser                                               */
/*      Seismographic Station                                           */
/*      University of California, Berkeley                              */
/*      doug@seismo.berkeley.edu                                        */
/*                                                                      */
/************************************************************************/

/*
 * Copyright (c) 1996 The Regents of the University of California.
 * All Rights Reserved.
 * 
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for educational, research and non-profit purposes,
 * without fee, and without a written agreement is hereby granted,
 * provided that the above copyright notice, this paragraph and the
 * following three paragraphs appear in all copies.
 * 
 * Permission to incorporate this software into commercial products may
 * be obtained from the Office of Technology Licensing, 2150 Shattuck
 * Avenue, Suite 510, Berkeley, CA  94704.
 * 
 * IN NO EVENT SHALL THE UNIVERSITY OF CALIFORNIA BE LIABLE TO ANY PARTY
 * FOR DIRECT, INDIRECT, SPECIAL, INCIDENTAL, OR CONSEQUENTIAL DAMAGES,
 * INCLUDING LOST PROFITS, ARISING OUT OF THE USE OF THIS SOFTWARE AND
 * ITS DOCUMENTATION, EVEN IF THE UNIVERSITY OF CALIFORNIA HAS BEEN
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * THE UNIVERSITY OF CALIFORNIA SPECIFICALLY DISCLAIMS ANY WARRANTIES,
 * INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE SOFTWARE
 * PROVIDED HEREUNDER IS ON AN "AS IS" BASIS, AND THE UNIVERSITY OF
 * CALIFORNIA HAS NO OBLIGATIONS TO PROVIDE MAINTENANCE, SUPPORT,
 * UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
 */

/************************************************************************/

/*      @(#)b2000_subs.h        1.1 09/09/97 19:04:12   */

int build_b2000 
(char           *rec,           /* input opaque data record.            */
 int            rec_len,        /* input opaque data record length.     */
 int            rec_type,       /* vendor-specific record type.         */
 char           *rec_str,       /* vendor-specific record type string.  */
 int            maxlen,         /* max opaque data length for blockette.*/
 char           **outp,         /* ptr to output blockette              */
 int            *outlen);       /* ptr to blockette len (OUT).          */

int build_bpr
(char           *rec,           /* input opaque data record.            */
 int            rec_len,        /* input opaque data record length.     */
 int            rec_type,       /* vendor-specific record type.         */
 char           *rec_str,       /* vendor-specific record type string.  */
 int            maxlen,         /* max opaque data length for blockette.*/
 char           *location,      /* location for SEED channel.           */
 char           *channel,       /* channel for SEED channel.            */
 SDR_TIME       *btime,         /* ptr to time (possibly NULL).         */
 char           **outp,         /* ptr to output blockette              */
 int            *outlen);       /* ptr to blockette len (OUT).          */
