'\" t
.\"
.\" To properly format this file, you must use the -man troff macros and tbl
.\"
.\%W% %G% %U%
.if n .na
.TH GPS_ASHTECH 1 "21 October 1998" BDSN
.SH NAME
gps_ashtech, gps_trimble - Read and log real-time GPS data.
.SH SYNOPSIS
On the Sun:
.LP
.B gps_ashtech
[\ \fB-h\fR\ ]
[\ \fB-c\ \fI config\fR\ ]
[\ \fB-m\ \fI module\fR\ ]
[\ \fB-n\fR\ ]
.if n .ti +5
[\ \fB-l\ \fI line\fR\ ]
[\ \fB-b\ \fI baud\fR\ ]
[\ \fB-p\ \fI parity\fR\ ]
[\ \fB-i\ \fI n\fR\ ]
.if t .ti +.5in
.if n .ti +5
[\ \fB-v\ \fI n\fR\ ]
[\ \fB-d\ \fI n\fR\ ]
[\ \fB-w\ \fI n\fR\ ]
[\ \fB-D\ \fI seconds\fR\ ]
.if n .ti +5
[\ \fB-f\ \fI format\fR\ ]
[\ \fB-C\ \fI channel\fR\ ]
[\ \fB-L\ \fI location\fR\ ]
.if t .ti +.5in
.if n .ti +5
[\ \fB-s\ \fI span\fR\ ]
[\ \fIinfile\fR\ ]
[\ \fIoutfile\fR\ ]
.LP
.B gps_trimble
[\ \fB-h\fR\ ]
[\ \fB-c\ \fI config\fR\ ]
[\ \fB-m\ \fI module\fR\ ]
[\ \fB-n\fR\ ]
.if n .ti +5
[\ \fB-l\ \fI line\fR\ ]
[\ \fB-b\ \fI baud\fR\ ]
[\ \fB-p\ \fI parity\fR\ ]
[\ \fB-i\ \fI n\fR\ ]
.if n .ti +5
.if t .ti +.5in
[\ \fB-v\ \fI n\fR\ ]
[\ \fB-d\ \fI n\fR\ ]
[\ \fB-w\ \fI n\fR\ ]
[\ \fB-D\ \fI seconds\fR\ ]
.if n .ti +5
[\ \fB-f\ \fI format\fR\ ]
[\ \fB-C\ \fI channel\fR\ ]
[\ \fB-L\ \fI location\fR\ ]
.if n .ti +5
.if t .ti +.5in
[\ \fB-s\ \fI span\fR\ ]
[\ \fIinfile\fR\ ]
[\ \fIoutfile\fR\ ]
.LP
On the Quanterra:
.LP
.B gps_ashtech
[\ \fB-h\fR\ ]
[\ \fB-c=\fIconfig\fR\ ]
[\ \fB-m=\fImodule\fR\ ]
[\ \fB-n\fR\ ]
.if n .ti +5
[\ \fB-l=\fIline\fR\ ]
[\ \fB-b=\fIbaud\fR\ ]
[\ \fB-p=\fIparity\fR\ ]
[\ \fB-i=\fIn\fR\ ]
.if n .ti +5
.if t .ti +.5in
[\ \fB-v=\fIn\fR\ ]
[\ \fB-d=\fIn\fR\ ]
[\ \fB-w=\fIn\fR\ ]
[\ \fB-D=\fIseconds\fR\ ]
.if n .ti +5
[\ \fB-f=\fIformat\fR\ ]
[\ \fB-C=\fIchannel\fR\ ]
[\ \fB-L=\fIlocation\fR\ ]
.if n .ti +5
.if t .ti +.5in
[\ \fIinfile\fR\ ]
[\ \fIoutfile\fR\ ]
.LP
.B gps_trimble
[\ \fB-h\fR\ ]
[\ \fB-c=\fIconfig\fR\ ]
[\ \fB-m=\fImodule\fR\ ]
[\ \fB-n\fR\ ]
.if n .ti +5
[\ \fB-l=\fIline\fR\ ]
[\ \fB-b=\fIbaud\fR\ ]
[\ \fB-p=\fIparity\fR\ ]
[\ \fB-i=\fIn\fR\ ]
.if n .ti +5
.if t .ti +.5in
[\ \fB-v=\fIn\fR\ ]
[\ \fB-d=\fIn\fR\ ]
[\ \fB-w=\fIn\fR\ ]
[\ \fB-D=\fIseconds\fR\ ]
.if n .ti +5
[\ \fB-f=\fIformat\fR\ ]
[\ \fB-C=\fIchannel\fR\ ]
[\ \fB-L=\fIlocation\fR\ ]
.if n .ti +5
.if t .ti +.5in
[\ \fIinfile\fR\ ]
[\ \fIoutfile\fR\ ]
.SH DESCRIPTION
The programs
.B gps_ashtech
and
.B gps_trimble
are programs designed to read real-time GPS data from an Ashtech Z-12 or
Trimble 4000 GPS receiver, and to output the data in one of several formats to
a specified output file or pipe.  The program can be compiled to run on either
a Sun SPARC computer or a Quanterra OS/9 datalogger under MultiSHEAR.

.B gps_ashtech
and
.B gps_trimble
can read raw GPS data either directly from a serial port or from an existing
raw GPS data file.  The program will read each GPS record, verify the framing
and checksum of the GPS record, optionally output the contents or attributes
of the record in ASCII format for debugging purposes, and write the verified
record in one of several formats.  The program will detect errors such as
missing or extraneous characters between records, incorrect record framing,
and record checksum errors. Any incomplete or corrupt records will be
discarded.  All debugging output and error messages are written to stderr.

Although the raw data format differs between the Ashtech and Trimble
receivers, data from both receivers is grouped into records.  Each record has
a recognizable record header, trailer, and contains some type of checksum or
crc.  The Ashtech receivers output an separate MBEN record for each observed
satellite in an epoch, a single PBEN record for each epoch, and an occasional
SNAV record.  The Trimble receivers construct a single structure for each
epoch which contains the information from all observed satellites.  It divides
the the epoch structure into a series of pages on output.  For the purpose of
this document and the programs, a Trimble page is considered to be equivalent
to a Ashtech record.

The programs can produce the following output formats:
.TP
raw format
.br
The raw output format is a bytestream containsing a copy of each verified raw
input record.  If no errors are encountered in the input data stream, the raw
output stream is identical to the input data stream.
.TP
Opaque data blockette format
.br
The opaque blockette output format consists of a stream of SEED opaque data
blockettes (blockette 2000), where each blockette contains one or more binary
GPS data record.
.TP
bpr format
.br
The bpr output format consists of SEED opaque data blockettes (blockettes
2000) which is encapulated in the structure required for processing by the
Quanterra aqblk program.  The Quanterra aqblk program is responsible to
creating a MiniSEED data stream with the encapsulated SEED blockettes on a
Quanterra MultiSHEAR datalogger.
.LP
.B gps_ashtech
and
.B gps_trimble
can be used as a diagnostic tool to examine a data stream from a GPS receiver
as well as to collect and log data.  When used with the debugging options,
attributes of each GPS data record will be output to stderr in ASCII format
which can be used to verify that data is being properly received from the GPS
receiver.  For Ashtech records, the fields of each record will be decoded and
displayed.  For Trimble pages, attributes of the page will decoded and
displayed, but the contents of each page are not displayed since they are
defined only in conjunction with all of the other pages for that epoch.

.B gps_ashtech
and
.B gps_trimble
are based on a common program base for generic gps data acquisition code
(gps_generic.c and related subroutines), with receiver-dependent subroutines
(ashtech_subs.c and trimble_subs.c).

Command line options and their arguments can be separated by whitespace or
appended to the option (standard Unix syntax) or may be separated by an
\fB=\fR (standard OS/9 syntax).  This document only shows the Unix syntax for
brevity.

.SH OPTIONS
.TP
.B \fB-h\fR
prints out a simple help message with syntax and explaination of the options.
.TP
\fB-c\ \fI config\fR
specifies the name of the configuration file containing configuration
information for this instance of the program.  The configuration file can be
used to specify configuration information instead of command line options.
The configuration file is always used when the program is run on a Quanterra.
The default configuration file on Quanterra is \fB/r0/aqcfg\fR.
There is no default configuration file on the Sun.  The configuration 
file format is compatible with Quanterra's MultiSHEAR aqcfg file.
\fBNOTE:\fR Values specified on the command line may override values in
the configuration file.  However, you may not specify conflicting information
on the command line and configuration file, such as input from both a
serial line and a file.
.TP
\fB-m\ \fI module\fR
specifies the module (or section) name in the configuration file.
A configuration file can contain information for many modules.
The section of the configuration file that contains information for this
instance of the program begins with the line \fB[\fImodule\fB]\fR,
and ends with a blank line (or end of file).  If no module name is
specified, the module name is name with which the program as invoked
(the filename portion of argv[0]).
.TP
.B \fB-n\fR
suppresses the creation and output of any output data.  Debugging
output will still be written to stdout, and errors will be written
to stderr.  This option overrides any explicit \fIoutfile\fR argument,
and will suppress data being written to stdout if \fIoutfile\fR is
not specified.
.TP
\fB-l\ \fI line\fR
specifies the serial line from which the program should read its input.
This option is mutually exclusive with the \fIinfile\fR argument.
If neither is specified, data will be read from stdin.  The serial line will
be configured for 8 data bits.
.TP  
\fB-b\ \fI baud\fR
specifies the baudrate of the input serial line.  The baudrate specified
should be the same as the output baudrate of the serial line of the GPS
receiver if the receiver is directly connected to the computer's serial port.
.TP
\fB-p\ \fI parity\fR
specifies the parity setting for the serial line.  The parity specified
should be the same as the parity setting of the serial line of the GPS
receiver if the receiver is directly connected to the computer's serial port.
Valid parity setting are 
.TS
l l l .
	\fBEVEN\fR or \fBeven\fR	even parity
	\fBODD\fR or \fBodd\fR	odd parity
	\fBNONE\fR or \fBnone\fR	no parity
.TE
.TP
\fB-i\ \fI n\fR
specifies the service interval of the serial line in millisecond increments.
The default value is 100 (100 milliseconds, or .1 second).
Both the Sun and Quanterra version of the code use multi-character
reads with non-blocking I/O.
.TP
\fB-v\ \fI n\fR
specifies the verbosity level of the program.  A verbosity greater than
0 will output increasing levels of diagnostic material.
Debugging output will be written to stdout unless data is written
to stdout, in which case debugging output is written to stderr.
.TP
\fB-d\ \fI n\fR
specifies debugging output.  Debugging values may be added together
to produce multipe types of debugging output.
.TS
l l l .
	1	debug record type
	2	debug full record
	4	debug input characters processing (very verbose)
.TE
Debugging output will be written to stdout unless data is written
to stdout, in which case debugging output is written to stderr.
.TP
\fB-w\ \fI n\fR 
specifies that the program should write a warning to stderr if no valid GPS
record is received within \fIn\fR seconds.  The system will generate up to 10
consecutive warning messages, and will then suppress additional messages until
a valid record is received.  When a valid GPS record is received, the timer is
reset, and a message stating that a record received will be generated if there
had been a warning message immediately preceeding this record.  A value of
0 (the default value) will suppress these warning messages.
.TP
\fB-D\ \fI seconds\fR 
specifies implicit decimation with an output interval in seconds.  The output
interval must be an integer multiple of the output sample interval of the GPS
receiver.  This option is only useful if you want a longer sample interval
(lower sample rate) than the receiver is generating, and you cannot change the
receiver sample interval.  The decimation process works by discarding all
observation records that are multiples of the decimation output interval from
the start of the day.  Decimation is only implemented for \fBgps_ashtech\fR.
.TP
\fB-f\ \fI format\fR
specified the output data format.  Options are:
.TS
l l l .
	\fBraw\fR	bytestream copy of input data record
	\fBb2000\fR	SEED blockette 2000 format
	\fBbpr\fR	blockette piped record (aqblk) format
.TE
The default output format is \fBraw\fR.
.TP
\fB-C\ \fI channel\fR
specifies the SEED channel to be used for the data stream.  This option
is only used with the bpr output format.  This option MUST be specified
when outputting data in \fBbpr\fR format since there is no default channel name.
.TP
\fB-L\ \fI location\fR
specifies the SEED location to be used for the data stream.  This option
is only used with the bpr output format.  The default location name is blank.
.TP
\fB-s\ \fI span\fR 
specifies the timespan of the output data file.  The timespan may be any
positive integer followed one of the letters: M = minutes, H = hours, d =
days.  If you specify the timespan in minutes, it must be an even divisor of 1
hour.  Currently, timespans of less than 1 hour are not well implented since
the filename standard used only has a granularity of one hour.  If a timespan
in specified, the output data will be written to a series of files 
named 
\fIsiteddd0.\fBr\fIhh\fR (gps_ashtech) or
\fIsiteddd0.\fBd\fIhh\fR (gps_trimble) where
.TS
l l l .
	site	sitename (specified as outfile argument)
	ddd	day of year
	hh	hour
.TE
If you do specify a timespan, you MUST specify an output file.
If you do not specify a timespan, data will be written to the
specified output file (or to stdout, if no output file is specified).
This option is not supported on the Quanterra version of the programs.
.TP
\fIinfile\fR
specifies the optional name of the input data file.  This argument
is mutually exclusive with the \fB-l\fR option.  If neither
a serial line nor input data file is specified, input data will
be read from stdin.
.TP
\fIoutfile\fR
specifies the optional name of the output data file.
This argument can only be specified when an input file or input port
is also specified.
If no output file is specified, data will be written to stdout.
If the output file 
When used in conjuntion with the \fB-s\fR option, outfile
is interpreted as the sitename, and is incorporated into the 
filename of the output files created for specific timespans.
.SH CONFIG FILE
The format of the configuration file adheres to the Quanterra MultiSHEAR aqcfg
file format.  A configuration file can contain configuration information for
multiple programs (or modules).  The information for each module is contained
in a separate section of the file.  Each module's section begins with a line
containing \fB[\fImodule\fB]\fR, and terminates with a blank line or
end-of-file.  Many of the configuration file directives provide identical
information to command line options.  Refer to the command line options
for additional details.

The format of configuration lines within each section is:
.TS
l l .
	keyword=value
.TE
Lines that begin with "*" are treated as comments.
The following keywords and values are supported:
.sp
.TS
l l .
	[\fImodule_name\fR]
	input=\fIinput_file\fR
	port=\fIinput_serial_line\fR
	baud=\fIbaudrate\fR
	parity=\fBodd\fR|\fBeven\fR|\fBnone\fR
	warnat=n
	output=\fIoutput_filename\fR
	decimate=\fBsample_interval\fR
	format=\fBraw\fR|\fBb2000\fR|\fBbpr\fR
	channel=\fISEED_channel\fR
	location=\fISEED_location\fR
	vendor=\fIvendor_name\fR
	model=\fIreceiver_model\fR
	software=\fIsoftware_name\fR
	firmware=\fIfirmware_version\fR
	flush=\fByes\fR|\fBno\fR|\fBepoch\fR
.TE
.sp
.TP
module_name 
would normally be the same as the program name (eg
\fBgps_ashtech\fR or \fBgps_trimble\fR) unless overridden by the
\fB-m\fR option.  
.TP
\fBinput\fR
specifies the name of the input file,
and is mutually exclusive with \fBport\fR;
.TP
\fBport\fR line specifies the name of the input serial line, 
and is mutually exclusive with \fBinput\fR. 
.TP
\fBbaud\fR and \fBparity\fR 
provide serial line configuration information.  
.TP
\fBwarnat\fR 
specifies the number of seconds after which warning messages should be written if no valid GPS data is received by
the program.
.TP
\fBoutput\fR
specifies the name of the output file.  If not specified, output will be
written to either stdout or to a timespan file (Sun only).
.TP
\fBdecimate\fR 
specifies the decimation sample interval, and is only supported by
\fBgps_ashtech\fR.

\fBformat\fR
specifies the format of the output data.  
.P
The remaining options are only used when outputing data in \fBbpr\fR format.  
.TP
\fBchannel\fR and \fBlocation\fR
specify the SEED channel and SEED location to which the data should be
assigned.
.TP
\fBvendor\fR, \fBmodel\fR, \fBsoftware\fR, and \fBfirmware\fR 
are information strings that can be placed in the header of each opaque
blockette.  See the definition of the SEED blockette 2000 for reference.
.TP
\fBflush\fR
specifies whether each SEED record should be flushed (or terminated) at
after each record, each epoch, or only when the record is full.
.SH EXAMPLES
1.  Read data from a Sun serial port, write raw data to 1 hour files for site abcd.
.sp
gps_ashtech -f /dev/ttya -b 9600 -p n -s 1H abcd

2.  Scan an existing raw data file, output record debugging info to stdout.
.sp
gps_ashtech -n -d 3 < infile

3.  Run the program on the Quanterra to log data, reading data from 
standard config file.
.sp
gps_ashtech <>/nil >>-/pipe/log.gps_ashtech ^1000 &
.sp
A sample configuration Quanterra configuration section:
.TS
l l .
	[gps_ashtech]
	port=/t1
	baud=9600
	parity=none
	output=/pipe/blk.bdsl.gps
	format=bpr
	channel=GPS
	vendor=ASHTECH
	model=Z-12
	software=
	firmware=1E86-1D01
	flush=epoch
.TE
.SH NOTES
In order to send GPS data to a MiniSEED data channel, the programs must be
used under MultiSHEAR on a Quanterra datalogger.  The aqblk program which
constructs the SEED channel from the output of these programs is not supported
under UltraSHEAR or SHEAR.
.SH SEE ALSO
qlog(1), datalog, comserv
.SH AUTHOR
Doug Neuhauser, UC Berkeley Seismological Laboratory, doug@seismo.berkeley.edu,
and
Ray Baxter, UC Berkeley Seismological Laboratory, ray@seismo.berkeley.edu.
