/************************************************************************/
/*  Datatypes and definitions from qlib2.h                              */
/************************************************************************/

/*      @(#)gps_seed.h  1.1 09/09/97 19:04:16   */

#ifndef SEED_BIG_ENDIAN     
#define SEED_LITTLE_ENDIAN      0
#define SEED_BIG_ENDIAN         1

typedef char            BYTE;   /* signed byte                          */
typedef unsigned char   UBYTE;  /* unsigned byte                        */
typedef short           WORD;   /* 16 bit signed                        */
typedef unsigned short  UWORD;  /* 16 bit unsigned                      */
typedef int             LONG;   /* 32 bit signed                        */
typedef unsigned int    ULONG;  /* 32 bit unsigned                      */
typedef char            CHAR;   /* 7 bit character, high bit 0          */
typedef unsigned char   UCHAR;  /* 8 bit character, unsigned.           */
typedef signed char     SCHAR;  /* 8 bit character, signed.             */
typedef float           FLOAT;  /* IEEE floating point                  */

typedef struct _sdr_time {
    UWORD       year;           /* Year                                 */
    UWORD       day;            /* Day of year (1-366)                  */
    UBYTE       hour;           /* Hour (0-23)                          */
    UBYTE       minute;         /* Minute (0-59)                        */
    UBYTE       second;         /* Second (0-60 (leap))                 */
    UBYTE       pad;            /* Padding                              */
    UWORD       ticks;          /* 1/10 millisecond (0-9999)            */
} SDR_TIME;

#endif
