/* strncasecmp is extracted from */
/* mshear/comserv/util/os9stuff.c */
/* strcasecmp is added because gcc2 does not have this in its library. */

/* compare two strings, ignoring case. Compare for a maximum of "n" characters
   returns 0 if strings are equal, -1 if string1 < string2, or
   1 if string1 > string2 */
int strncasecmp(const char *string1, const char *string2, int n)
{
      short i ;
      char c1, c2 ;
      
      i = 0 ;
      while ((i < n) && (string1[i] != 0) &&(string2[i] != 0)) 
        {
          c1 = toupper(string1[i]) ;
          c2 = toupper(string2[i]) ;
          if (c1 < c2)
              return -1 ;
          if (c1 > c2)
              return 1 ;
          i++ ;
        }
      if (i >= n)
          return 0 ; /* compared the maximum number of characters */
      if (string1[i] == 0)
          if (string2[i] == 0)
              return 0 ; /* both the same */
            else
              return -1 ; /* string1 is shorter */
        else
          return 1 ; /* string1 is longer */
}

/* compare two strings, ignoring case. For some reason, Microware forgot this one
   returns 0 if strings are equal, -1 if string1 < string2, or
   1 if string1 > string2 */
int strcasecmp(const char *string1, const char *string2)
{
      return strncasecmp(string1, string2, 32000) ;
}


